#ifndef __CH32FLASH_H
#define __CH32FLASH_H

#include "ch32f10x.h"

#define FLASH_PAGE_SIZE  128

#define CH32_FLASH_SIZE  64      //ѡCH32FLASHСλΪK
#define CH32_FLASH_WREN  1       //ʹFLASHд루0ʹܣ1ʹܣ

#define CH32_SECTOR_SIZE 1024    

#define CH32_FLASH_BASE  0X08000000     //CH32 FLASH ʼַ

u16  CH32FLASH_ReadHalfWord(u32 faddr);		                          //  
void CH32FLASH_Write128(u32 WriteAddr,u16 *pBuffer,u16 NumToWrite); //ٱ̣128ֽڱ
void CH32FLASH_WriteLenByte(u32 WriteAddr,u32 DataToWrite,u16 Len); //ַָʼдָȵ
u32  CH32FLASH_ReadLenByte(u32 ReadAddr,u16 Len);						        //ַָʼȡָ
void CH32FLASH_Write(u32 WriteAddr,u16 *pBuffer,u16 NumToWrite);		//ַָʼдָȵ
void CH32FLASH_Read(u32 ReadAddr,u16 *pBuffer,u16 NumToRead);   		//ַָʼָȵ

//д
void Test_Write(u32 WriteAddr,u16 WriteData);								   

#endif

