/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2019/10/15
* Description        : Main program body.
*******************************************************************************/ 
//IAPʵ

#include "debug.h"
#include "ch32flash.h"
#include "iap.h"
#include "usart.h"
#include "key.h"

/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main(void)
{
	u8  key;
	u16 oldcount=0;				//ϵĴڽֵ
	u16 applenth=0;				//յapp볤
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
  Delay_Init();
	uart_init(115200);                             /* printf using USART1 */
	KEY_Init();
                                                 
	while(1)
  {
	 	if(USART_RX_CNT)
		{
			if(oldcount==USART_RX_CNT)//,ûյκ,Ϊݽ.
			{
				applenth=USART_RX_CNT;
				oldcount=0;
				USART_RX_CNT=0;
				printf("û!\r\n");
				printf("볤:%dBytes\r\n",applenth);
			}
			else 
			{
				oldcount=USART_RX_CNT;
			}
		}		
    Delay_Ms(20);		
		key=KEY_Scan(0);
		if(key==KEY0_PRES)
		{	
			if(applenth)
			{
				printf("ʼ¹̼...\r\n");	

				if(((*(vu32*)(0X20001000+4))&0xFF000000)==0x08000000)//жǷΪ0X08XXXXXX.
				{	 
					printf("̼!\r\n");	
					iap_write_appbin(FLASH_APP1_ADDR,USART_RX_BUF,applenth);//FLASH   
					printf("̼!\r\n");	
				}
				else 
				{   
					printf("FLASHӦó!\r\n");
				}
			}
			else 
			{
				printf("ûпԸµĹ̼!\r\n");
			}	
		}
		
	  if(key==KEY1_PRES)
		{
			if(applenth)
			{																	 
				printf("̼!\r\n");    
				applenth=0;
			}
			else 
			{
				printf("ûпĹ̼!\r\n");
			}	
		}		
		
		if(key==KEY2_PRES)
		{
			printf("뿪ʼFLASHִ!\r\n");
			iap_load_app(FLASH_APP1_ADDR);//ִFLASH APP					 
		}				
	}
}



