
#include "ch32flash.h"
#include "ch32f10x_flash.h"
#include "string.h"

//ȡַָİ(16λ)
//faddr:ַ(˵ַΪ2ı!!)
//ֵ:Ӧ.
u16 CH32FLASH_ReadHalfWord(u32 faddr)
{
	return *(vu16*)faddr; 
}

#if CH32_FLASH_WREN	//ʹд 
//д
//WriteAddr:ʼַ
//pBuffer:ָ
//NumToWrite:(16λ)   
void CH32FLASH_Write_NoCheck(u32 WriteAddr,u16 *pBuffer,u16 NumToWrite)   
{ 			 		 
	u16 i;
	for(i=0;i<NumToWrite;i++)
	{
		  FLASH_ProgramHalfWord(WriteAddr,pBuffer[i]);
	    WriteAddr+=2;//ַ2.
	}  
} 

u32 buf[256];      //512wordתΪ256wordÿд32word
void CH32FLASH_Write128(u32 WriteAddr,u16 *pBuffer,u16 NumToWrite)
{
	u16 i;
  u32 pageAddrs;
  u16 j = 0;
	
	FLASH_Unlock_Fast();
	
	for(i=0;i<NumToWrite/2;i++)
	{
    buf[i] = (((u32)pBuffer[2*i+1])<<16)| pBuffer[2*i]; //˴Ҫעߵλ˳
	}
	
	for(i = 0; i < 8; i++)
	{
			pageAddrs = WriteAddr + i*128;
			j = i*32;
			FLASH_BufReset();
			FLASH_BufLoad(pageAddrs, buf[j+0], buf[j+1], buf[j+2], buf[j+3]);
			FLASH_BufLoad(pageAddrs + 0x10, buf[j+4], buf[j+5], buf[j+6], buf[j+7]);
			FLASH_BufLoad(pageAddrs + 0x20, buf[j+8], buf[j+9], buf[j+10], buf[j+11]);
			FLASH_BufLoad(pageAddrs + 0x30, buf[j+12], buf[j+13], buf[j+14], buf[j+15]);
			FLASH_BufLoad(pageAddrs + 0x40, buf[j+16], buf[j+17], buf[j+18], buf[j+19]);
			FLASH_BufLoad(pageAddrs + 0x50, buf[j+20], buf[j+21], buf[j+22], buf[j+23]);
			FLASH_BufLoad(pageAddrs + 0x60, buf[j+24], buf[j+25], buf[j+26], buf[j+27]);
			FLASH_BufLoad(pageAddrs + 0x70, buf[j+28], buf[j+29], buf[j+30], buf[j+31]);        
			FLASH_ProgramPage_Fast(pageAddrs);
	}
  
	FLASH_Lock_Fast();	
}

//ַָʼдָȵ
//WriteAddr:ʼַ(˵ַΪ2ı!!)
//pBuffer:ָ
//NumToWrite:(16λ)(Ҫд16λݵĸ.)

u16 CHFLASH_BUF[CH32_SECTOR_SIZE/2];//2Kֽ

void CH32FLASH_Write(u32 WriteAddr,u16 *pBuffer,u16 NumToWrite)	
{
	u32 secpos;	   //ַ˴ַָSTM32ÿҳͷַÿҳ1K
	u16 secoff;	   //ƫƵַ(16λּ)
	u16 secremain; //ʣַ(16λּ)	   
 	u16 i;    
	u32 offaddr;   //ȥ0X08000000ĵַ
	
	if(WriteAddr<CH32_FLASH_BASE||(WriteAddr>=(CH32_FLASH_BASE+(1024*CH32_FLASH_SIZE)))) //Ƿַ
	{
		return;
	}
	
	FLASH_Unlock();					             	//
	
	offaddr=WriteAddr-CH32_FLASH_BASE;		//ʵƫƵַ.
	secpos=offaddr/CH32_SECTOR_SIZE;		  //ַ˴Ӧָжٸ
	secoff=(offaddr%CH32_SECTOR_SIZE)/2;	//ڵƫ(2ֽΪλ.)˴ȥҳ֮ʣٸֽڣ2ΪSTM32ÿα̿д16λ2ֽڣ
	secremain=CH32_SECTOR_SIZE/2-secoff;	//ʣռС   
	
	if(NumToWrite<=secremain)
	{
		secremain=NumToWrite;//ڸΧ
	}
	
	while(1) 
	{	
		CH32FLASH_Read(secpos*CH32_SECTOR_SIZE+CH32_FLASH_BASE,CHFLASH_BUF,CH32_SECTOR_SIZE/2);//ݣҪдַͷַʼ
		
		for(i=0;i<secremain;i++)//УݣжϸĿǷǿյ
		{
			if(CHFLASH_BUF[secoff+i]!=0XFFFF)break; 	  
		}
		
		if(i<secremain)//Ҫ
		{
			FLASH_ErasePage(secpos*CH32_SECTOR_SIZE+CH32_FLASH_BASE);//
			for(i=0;i<secremain;i++)//
			{
				CHFLASH_BUF[i+secoff]=pBuffer[i];	  
			}
			CH32FLASH_Write128(secpos*CH32_SECTOR_SIZE+CH32_FLASH_BASE,CHFLASH_BUF,CH32_SECTOR_SIZE/2);  
			//CH32FLASH_Write_NoCheck(secpos*CH_SECTOR_SIZE+CH32_FLASH_BASE,CHFLASH_BUF,CH_SECTOR_SIZE/2);//д  
		}
		else CH32FLASH_Write128(WriteAddr,pBuffer,secremain);//дѾ˵,ֱдʣ. 	
		//else CH32FLASH_Write_NoCheck(WriteAddr,pBuffer,secremain);//дѾ˵,ֱдʣ. 		
		
		if(NumToWrite==secremain)break;//д
		
		else//дδ
		{
			secpos++;				       //ַ1
			secoff=0;				       //ƫλΪ0 	 
		  pBuffer+=secremain;  	 //ָƫ
			WriteAddr+=secremain;	 //дַƫ	   
		  NumToWrite-=secremain; //ֽ(16λ)ݼ
			if(NumToWrite>(CH32_SECTOR_SIZE/2))secremain=CH32_SECTOR_SIZE/2;//һд
			else secremain=NumToWrite;//һд
		}	 
	};	
	FLASH_Lock();//
}
#endif


//ַָʼָȵ
//ReadAddr:ʼַ
//pBuffer:ָ
//NumToWrite:֣16λ
void CH32FLASH_Read(u32 ReadAddr,u16 *pBuffer,u16 NumToRead)   	
{
	u16 i;
	for(i=0;i<NumToRead;i++)
	{
		pBuffer[i]=CH32FLASH_ReadHalfWord(ReadAddr); //ȡֽ
		ReadAddr+=2;  //ƫֽ
	}
}

//WriteAddr:ʼַ
//WriteData:Ҫд
void Test_Write(u32 WriteAddr,u16 WriteData)   	
{
	CH32FLASH_Write(WriteAddr,&WriteData,1);  //дһ
}
